Set up Code Review office hours
Closed, ResolvedPublic

Description

This was mentioned as one item in the Developer Summit session T114419 and hence is a subtask of T101686.

Action items:
@greg: set up CR office hours (start the practice)

This task seeks to find a format of code review office hours and implement it.


Office Hours scheduled for Thursdays at 20:00 UTC: E179: Code Review Office Hours


{V9}

There are a very large number of changes, so older changes are hidden. Show Older Changes
greg moved this task from Next to In Progress on the User-greg board.Mar 14 2016, 10:50 PM

Copying from wikitech-l

We have two swat windows every day. It's magical... I post a request for a deploy on a Wiki page and someone deploys it.

Could we try a similar thing with code review. Code review window (maximum 1 patch per person) and have a group of +2ers look at a maximum set of patches?

It would need a few more rules than that and a bit of tweaking but seems like a good experiment. I'd sign up to help it if it was a maximum 2 windows for me a week.

greg moved this task from In Progress to Next on the User-greg board.Mar 17 2016, 12:36 AM
greg added a comment.Mar 29 2016, 9:15 PM

Could we try a similar thing with code review. Code review window (maximum 1 patch per person) and have a group of +2ers look at a maximum set of patches?

It would need a few more rules than that and a bit of tweaking but seems like a good experiment. I'd sign up to help it if it was a maximum 2 windows for me a week.

Interesting, that's a bit more involved than what I had in mind at first (just, essentially, a time and a place for people to work on code-review together, no explicit requirement of someone with +2 being around). But, obviously, that'd probably make the code-review session more productive, otherwise we might just have a "+1 everything" session :)

I'll respond on-list...

greg moved this task from Next to In Progress on the User-greg board.Mar 29 2016, 9:22 PM
ksmith added a subscriber: ksmith.Mar 29 2016, 10:03 PM

Although this is not within TPG's current scope, I have some personal interest, and would be interested in observing/participating in any experiments.

Dereckson updated the task description. (Show Details)Mar 30 2016, 2:09 AM

I would click on a poll option along the lines of "I'm in, as an observer/facilitator/advisor", if there were one.

DStrine removed a subscriber: DStrine.Mar 30 2016, 6:21 PM
Tgr added a subscriber: Tgr.Mar 30 2016, 7:37 PM
Dereckson added a comment.EditedMar 30 2016, 8:36 PM

Would have thought it were included in CR+1 role, but I imagine that would restrict the scope of what you describe at patch level instead of window level.

brion added a subscriber: brion.Mar 31 2016, 9:15 PM
greg added a comment.Apr 1 2016, 10:57 PM

If anyone watching this task is at the Hackathon right now: Feel free to talk to more people there about it and get them to vote/comment here. I think that audience would be perfect for this idea :) (Sadly I'm not at the hackathon this year.)

greg moved this task from In Progress to Next on the User-greg board.Apr 11 2016, 9:28 PM

Taking this one from @greg since he's currently out on maternity leave: {E163}

@Luke081515 created #wikimedia-codereview on freenode and I'm going to create some events on the phab calendar.

@Luke081515 created #wikimedia-codereview on freenode and I'm going to create some events on the phab calendar.

I've seen #wikimedia-tech get some use for code development and review lately and it's been very refreshing to see. We also have #mediawiki (and #wikimedia-dev and...) of course.

@MZMcBride: I think having a channel without wikibugs notifications or other distractions might be best? I know we already have a ton of channels but it feels right to me, to have one dedicated for something as important as code review.

a channel without wikibugs notifications or other distractions might be best

Both wikimedia-tech and mediawiki qualify. It's extremely sad that another channel has been created.

Nemo_bis removed a subscriber: Nemo_bis.Apr 17 2016, 7:00 AM

Change 283850 had a related patch set uploaded (by Luke081515):
Display messages from mediawiki/core at #wikimedia-codereview

https://gerrit.wikimedia.org/r/283850

@MZMcBride: I think having a channel without wikibugs notifications or other distractions might be best? I know we already have a ton of channels but it feels right to me, to have one dedicated for something as important as code review.

Next argument? Because now, the distractions are coming.

By the way, I see how we could keep the bot without too many distraction.

Once we have experimented and found the best format to let people with code to review note the code review ID, currently Gerrit change ID, we'll prepare a change to allow the bot to get this list and filter to only current reviews about these changes, ignoring others. Bonus point: we'll also have notifications about non core changes in review.

Once we have experimented and found the best format to let people with code to review note the code review ID, currently Gerrit change ID, we'll prepare a change to allow the bot to get this list and filter to only current reviews about these changes, ignoring others. Bonus point: we'll also have notifications about non core changes in review.

Sounds like a good idea. So what are the next steps? I guess we should

  • create the next "review hours"
    • A bot like jouncebot for SWAT might be good for this codereview hours too
  • Create a wikitech or mediawiki page which shows who helps out for which repos (I can prepare one at wikitech)
  • Make this channel more popular to let more reviewers and change submiters join
Dereckson added a comment.EditedApr 17 2016, 12:30 PM

As it's targeted to MediaWiki developers, and not only for Wikimedia operations and other servers stuff, it would be more natural to publish it on mediawiki.org.

I've tried to summarize the first ideas of the process and the goals etc. here. Feel free to change things.

I'm currently writing at an IRC bot, which can help us at that channel like jouncebot does it for SWATs.

Change 283850 merged by Yuvipanda:
Display messages from mediawiki/core at #wikimedia-codereview

https://gerrit.wikimedia.org/r/283850

Qgil added a subscriber: Qgil.EditedApr 18 2016, 6:22 AM

It is very nice to see that this effort is getting momentum! Thank you very much to all contributors.

On the creation of the new channel, I think it is important to support the decisions of the drivers of this task. A new IRC channel is not a good or a bad thing in itself (and yes, I know the theory about not creating new channels unnecessarily). This task is an experiment, and everything is subject to improvement. If the new channel is useful let's keep it. If it is not, let's remove it after a trial period.

I don't know how many times it needs to be said - it's not a technical problem, it's a social one. Creating new IRC channels with new bots isn't going to help. It's just going to hide the problem in some obscure corner where most of what's left of our community isn't actually around to help.

I have no objection to people "experimenting" - until those experiments start getting in the way of normal business, which is what's currently happening. :-(

Qgil added a comment.Apr 18 2016, 8:29 AM

I think the perspective of generalistic and full time contributors able to follow the activity of channels like wikimedia-tech (MZ, Nemo, and Lego are good examples) is different than the perspective of contributors willing to concentrate on efforts requiring a special focus (like fixing the code review problem, something that Mukunda, Luke, and Dereckson want to do here).

"Normal business" is different for different contributors, and normal business was not enough to fix the problem this task aims to address. I think it is fair to challenge the current status trying other ways of recruiting and coordinating help (office hours, an IRC channel).

How exactly this effort causes problems to contributors like MZ, Nemo, Lego...?

I think the perspective of generalistic and full time contributors able to follow the activity of channels like wikimedia-tech (MZ, Nemo, and Lego are good examples) is different than the perspective of contributors willing to concentrate on efforts requiring a special focus

This makes no sense, grrrit-wm will emit significantly (I'd estimate 10x more) more messages about mediawiki/core patches than the amount of lines that are spoken in #wikimedia-tech on a daily basis (excluding outages). I mean look at http://bots.wmflabs.org/~wm-bot/logs/%23wikimedia-codereview/20160418.txt, and compare to http://bots.wmflabs.org/~wm-bot/logs/%23wikimedia-tech/20160418.txt.

(like fixing the code review problem, something that Mukunda, Luke, and Dereckson want to do here).

Please don't insinuate that I am not interested in fixing the code review problem. I'm just more interested in fixing it through my actions instead of constantly just talking about it.

"Normal business" is different for different contributors, and normal business was not enough to fix the problem this task aims to address. I think it is fair to challenge the current status trying other ways of recruiting and coordinating help (office hours, an IRC channel).

Like I said, that's fine. However if those experiments begin to interfere with the CR I need to get done, then that's a problem.

How exactly this effort causes problems to contributors like MZ, Nemo, Lego...?

I was specifically referring to https://gerrit.wikimedia.org/r/#/c/283850/2, which I was pretty frustrated about last night, even though it was just an accident. Thank you to @wctaiwan and @yuvipanda for fixing it :)

But more generally, if people begin discussing patches in a separate channel fragmented away from where everyone else is, how am I supposed to help? Many of my reviews are "drive-by" because I see people discussing them on IRC and have an opinion that I think will be helpful. Fragmenting what community we have left seems like a terrible idea. Instead, I'd like to point to an example which I really like, and that's been @coren's use of #wikimedia-tech, which seems to have been effective in getting CR and people excited about his project. Kudos!

The situation with grrrit-vm at the moment is not optimal, I agree. The original intention was to let people track the review progress at code review hours. Maybe we should set the bot quiet, if there is no code-review hour at the moment, I'm unsure at the moment.

@Legoktm: That was an honest mistake. I can only offer my apologies that we inconvenienced you.

I really don't think we need grrrit-wm for code review office hours. If anything a custom bot is in order.

In a perfect world, we would have a general #wikimedia dev channel, without bots, to discuss anything development related. And another channel for notifications.

I've only recently understood #wikimedia tech is taking the role #wikimedia dev had before the bot invasion.

The code review windows could be a real thing totally integrated to regular workflow. So if people confirms #wikimedia tech is A. a quiet channel B. a channel where development discussion happens, it's totally suitable for code review.

We have experience with this: on #wikimedia operations, the communication around SWAT is effective.

About bot and code review, we don't really need bot notifications, or if really people wants Gerrit notifications in real time about their changes, only for the changes in review, like I noted in a previous comment.

hashar added a subscriber: hashar.Apr 18 2016, 8:18 PM

The discussion on this task is going way out of the topic of setting up a review hour. Just agree on using either of #mediawiki or wikimedia-dev. If the bots are a concern, kick or mute them temporarily (with /mode +q somebot).

I tend to agree there are already enough channels as such and adding yet another one is adding confusion. At the same time the grrrit-wm and wikibugs bots are way too spammy during busy hours, that is part of the reason I am no more joining the #mediawiki or #wikimedia-dev channels, they are no more human friendly. I would suggest to stop sending notification for any events and just focus on new patches and merge/abandon and for task on new task, then send the rest to a feed channel. After all most tasks only involve a handful of people that receives mail and it is really pointless for hundred of people to receive the whole spam.

wctaiwan removed a subscriber: wctaiwan.Apr 18 2016, 8:45 PM

Perhaps, some of the disucssions should be spilt into sub/blocking tasks so its easier to follow and discuss certain matters withouth everything getting interwoven.

#mediawiki or #wikimedia-dev channels, they are no more human friendly.

There are no bots on #mediawiki anymore. The channel is dead though because we have created channels for each team, department, topic...

This is getting very bikesheddy...

I personally think these bots would be useful during CR office hours because:

  • having a bot say something has been +2 acts as a symbol of success. I think announcing succesful patches would add excitement to the atmosphere
  • during cr office hour, conversation is inevitably going to be split between gerrit and the channel when doing reviews. Having bots makes sure people stay in the loop seems like it would be helpful

Having it in #wikimedia-dev (or #mediawiki) would help involving drive by participants.

Personally, i have pretty severe new channel fatigue

All this is pretty superficial. It doesnt matter where its hosted provided it actually happens

I can add a function to my bot, that the bot unquiets the needed bots for CR hour, and quiets them after that automatically. But for this a) the bot needs +o, and b) we need a channel, which normaly don't uses bots.

Restricted Application added a subscriber: TerraCodes. · View Herald TranscriptApr 19 2016, 5:59 PM
mmodell updated the task description. (Show Details)May 7 2016, 9:32 PM
mmodell raised the priority of this task from Low to Normal.May 7 2016, 9:35 PM
mmodell closed this task as Resolved.May 9 2016, 4:18 AM
hashar added a comment.May 9 2016, 7:54 AM

From Mukunda email to wikitech-l:

Starting Thursday May 12th, 13:00 PDT ( 20:00 GMT ) we will be having the first weekly Code Review office hours on freenode IRC in the #wikimedia-codereview channel.

Event details: E179

Luke081515 removed a project: Patch-For-Review.
Tgr added a comment.Jun 7 2017, 6:27 PM

Apparently there is a #wikimedia-codereview and a #mediawiki-codereview channel, and the latter is invite-only, which confuses people. Could someone with the right IRC permissions make one a redirect to the other?